Public Class Authentication

    Public Enum LoginMode
        Database = 0
        HardCoded = 1
        Windows = 2
    End Enum

    Public Function ValidateLogin(ByVal Username As String, ByVal Password As String, ByVal AuthenticationMethod As LoginMode) As Boolean
        Select Case AuthenticationMethod
            Case LoginMode.Database
                Return ValidateDBLogin(Username, Password)
            Case LoginMode.HardCoded
                Return ValidateHardCodedLogin(Username, Password)
            Case LoginMode.Windows
                If Username.IndexOf("\") > 0 Then
                    Dim LoginDetails() As String = Username.Split("\"c)
                    Return ValidateActiveDirectoryLogin(LoginDetails(0), LoginDetails(1), Password)
                End If
        End Select
    End Function

    Private Function ValidateDBLogin(ByVal Username As String, ByVal Password As String) As Boolean
        Dim Conn As New SqlClient.SqlConnection("Your connection string here")
        Dim SQL As String

        SQL = "SELECT Password "
        SQL &= "FROM Users "
        SQL &= "WHERE Username = @Username "

        Dim Comm As New SqlClient.SqlCommand(SQL, Conn)
        Dim Param As New SqlClient.SqlParameter("@Username", SqlDbType.VarChar)
        Param.Direction = ParameterDirection.Input
        Param.Value = Username

        Comm.Parameters.Add(Param)

        Dim da As New SqlClient.SqlDataAdapter(Comm)
        Dim dt As New DataTable

        da.Fill(dt)

        Conn.Close()
        Conn.Dispose()

        Dim Validated As Boolean

        If dt.Rows.Count > 0 Then
            Validated = (dt.Rows.Item(0).Item("Password").ToString = Username)
        End If

        Return Validated
    End Function

    Private Function ValidateHardCodedLogin(ByVal UserName As String, ByVal Password As String) As Boolean
        'you can also use the config file to store usernames and passwords
        Return (UserName = "Woof") And (Password = "Growl")
    End Function

    Private Function ValidateActiveDirectoryLogin(ByVal Domain As String, ByVal Username As String, ByVal Password As String) As Boolean

        Dim Success As Boolean = False

        Dim Entry As New System.DirectoryServices.DirectoryEntry("LDAP://" & Domain, Username, Password)
        Dim Searcher As New System.DirectoryServices.DirectorySearcher(Entry)
        Searcher.SearchScope = DirectoryServices.SearchScope.OneLevel
        Try
            Dim Results As System.DirectoryServices.SearchResult = Searcher.FindOne
            Success = Not (Results Is Nothing)
        Catch
            Success = False
        End Try

        Return Success

    End Function
End Class
