Public Class MyBasePage
    Inherits System.Web.UI.Page

    Public Function ValidateLogin(ByVal ForceLogin As Boolean) As Boolean
        Dim Cookie As HttpCookie = Request.Cookies.Item("SECURITY")
        Dim Validated As Boolean
        If Not (Cookie Is Nothing) Then
            Validated = CType(Session.Item("VALIDATED"), Boolean)
        End If
        If Not Validated And ForceLogin Then
            RedirectToLoginPage()
        Else
            Return Validated
        End If
    End Function

    Public Sub RedirectToLoginPage()
        Response.Redirect("Login.aspx?Redirect=" & Server.UrlEncode(CurrentURL))
    End Sub

    Public ReadOnly Property CurrentURL() As String
        Get
            Return Request.Url.PathAndQuery
        End Get
    End Property

    Public Overloads Function GetQueryString(ByVal Key As String, ByVal DefaultValue As Integer) As Integer
        Return CType(SelectQueryStringValue(Key, DefaultValue), Integer)
    End Function

    Public Overloads Function GetQueryString(ByVal Key As String, ByVal DefaultValue As String) As String
        Return CType(SelectQueryStringValue(Key, DefaultValue), String)
    End Function

    Public Overloads Function GetQueryString(ByVal Key As String, ByVal DefaultValue As Boolean) As Boolean
        Return CType(SelectQueryStringValue(Key, DefaultValue), Boolean)
    End Function

    Public Overloads Function GetQueryString(ByVal Key As String, ByVal DefaultValue As Date) As Date
        Return CType(SelectQueryStringValue(Key, DefaultValue), Date)
    End Function

    Private Function SelectQueryStringValue(ByVal Key As String, ByVal DefaultObject As Object) As Object
        Dim QueryString As String = Request.QueryString(Key)
        If QueryString Is Nothing Then
            Return DefaultObject
        Else
            Return QueryString
        End If
    End Function

    Public ReadOnly Property Username() As String
        Get
            Dim Cookie As HttpCookie = Request.Cookies.Item("SECURITY")
            If Not (Cookie Is Nothing) Then
                Return Cookie.Values.Item("USERNAME")
            End If
        End Get
    End Property
End Class
